<?php
// $Id: global.php,v 1.3 2005/09/16 14:32:19 landseer Exp $
// ----------------------------------------------------------------------
// PostNuke Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Hinrich Donner
// changed to pn_bbcode: larsneo
// ----------------------------------------------------------------------

define('_PNBBCODE_ENABLEDISPLAYHOOK', 'Enable displayhook');

define('_PNBBCODE_ADMINCODECONFIG', 'Configuration [code][/code]');
define('_PNBBCODE_ADMINCOLORCONFIG', 'Configuration [color][/color]');
define('_PNBBCODE_ADMINISTRATION', 'pn_bbcode Administration');
define('_PNBBCODE_ADMINQUOTECONFIG', 'Configuration [quote][/quote]');
define('_PNBBCODE_ADMINSIZECONFIG', 'Configuration [size][/size]');
define('_PNBBCODE_ARGSERROR',                 '[pn_bbcode] Internal error! Arguments missing!');
define('_PNBBCODE_BOLD', 'b');
define('_PNBBCODE_BOLD_HINT', 'bold text');
define('_PNBBCODE_CODE', 'Code');
define('_PNBBCODE_CODEHINT', '%h = Header (_PNBBCODE_CODE), %c=lines of code, %j=lines of code, escaped for javasript');
define('_PNBBCODE_CODE_ADDLINENUMBERS', 'Add line numbers');
define('_PNBBCODE_CODE_HINT', 'insert code');
define('_PNBBCODE_CODE_SYNTAXHIGHLIGHTING', 'Highlight code');
define('_PNBBCODE_COLOR_ALLOWUSERCOLOR', 'Allow userdefined text color');
define('_PNBBCODE_COLOR_BLACK', 'Black');
define('_PNBBCODE_COLOR_BLUE', 'Blue');
define('_PNBBCODE_COLOR_BROWN', 'Brown');
define('_PNBBCODE_COLOR_CYAN', 'Cyan');
define('_PNBBCODE_COLOR_DARKBLUE', 'Dark Blue');
define('_PNBBCODE_COLOR_DARKRED', 'Dark Red');
define('_PNBBCODE_COLOR_DEFAULT', 'Standard');
define('_PNBBCODE_COLOR_DEFINE', 'self defined color');
define('_PNBBCODE_COLOR_ENABLE', 'Enable flexible text colors');
define('_PNBBCODE_COLOR_GREEN', 'Green');
define('_PNBBCODE_COLOR_HINT', 'select font color');
define('_PNBBCODE_COLOR_INDIGO', 'Indigo');
define('_PNBBCODE_COLOR_OLIVE', 'Olive');
define('_PNBBCODE_COLOR_ORANGE', 'Orange');
define('_PNBBCODE_COLOR_RED', 'Red');
define('_PNBBCODE_COLOR_TEXTCOLORCODE', 'enter color code');
define('_PNBBCODE_COLOR_VIOLET', 'Violet');
define('_PNBBCODE_COLOR_WHITE', 'White');
define('_PNBBCODE_COLOR_YELLOW', 'Yellow');
define('_PNBBCODE_CONFIGCHANGED', 'Configuration has been changed');
define('_PNBBCODE_ENTER_EMAIL_ADDRESS','Enter the email address you want to add');
define('_PNBBCODE_ENTER_LIST_ITEM','Enter the new list item. Note that each list group must be preceeded by a List Open and must be ended with List Close');
define('_PNBBCODE_ENTER_PAGE_TITLE','Page title');
define('_PNBBCODE_ENTER_SITE_TITLE','Enter the web site title');
define('_PNBBCODE_ENTER_TEXT_BOLD','Enter the text that you want to make bold');
define('_PNBBCODE_ENTER_TEXT_ITALIC','Enter the text that you want to make italic');
define('_PNBBCODE_ENTER_TEXT_UNDERLINE','enter the underlined text');
define('_PNBBCODE_ENTER_URL','Enter the URL for the link you want to add');
define('_PNBBCODE_ENTER_WEBIMAGE_URL','Enter the URL for the image you want to display');
define('_PNBBCODE_FONTCOLOR', 'Font color');
define('_PNBBCODE_FONTSIZE', 'Font size');
define('_PNBBCODE_IMAGE', 'Image');
define('_PNBBCODE_IMAGE_HINT', 'insert an image');
define('_PNBBCODE_ITALIC', 'i');
define('_PNBBCODE_ITALIC_HINT', 'italic text');
define('_PNBBCODE_LISTCLOSE', '/ul');
define('_PNBBCODE_LISTCLOSE_HINT', 'close list');
define('_PNBBCODE_LISTITEM', 'li');
define('_PNBBCODE_LISTITEM_HINT', 'add list entry');
define('_PNBBCODE_LISTOPEN', 'ul');
define('_PNBBCODE_LISTOPEN_HINT', 'open list');
define('_PNBBCODE_MAIL', 'Email');
define('_PNBBCODE_MAIL_HINT', 'insert an email address');
define('_PNBBCODE_NO', 'No');
define('_PNBBCODE_NOAUTH', 'No permission');
define('_PNBBCODE_NOSCRIPTWARNING', 'Your browser does not support javascript or you turned it off. This means that several features on this page will not work as intended');
define('_PNBBCODE_NOSPECIALCODE', 'no special code');
define('_PNBBCODE_NOTALLOWEDTOSEEEMAILS', '*Not allowed to see emails*');
define('_PNBBCODE_NOTALLOWEDTOSEEEXTERNALLINKS', '*Not allowed to see the external links*');
define('_PNBBCODE_ORIGINALSENDER', 'From');
define('_PNBBCODE_PNADMINISTRATION', 'Administration');
define('_PNBBCODE_PREVIEW','Preview');
define('_PNBBCODE_QUOTE', 'Quote');
define('_PNBBCODE_QUOTEHINT', '%u = username, %t=quoted text');
define('_PNBBCODE_QUOTE_HINT', 'insert quote');
define('_PNBBCODE_SELECTCODE', 'select code type');
define('_PNBBCODE_SIZE_ALLOWUSERSIZE', 'Allow userdefined text size');
define('_PNBBCODE_SIZE_DEFINE', 'self defined size');
define('_PNBBCODE_SIZE_ENABLE', 'Enable flexible text size');
define('_PNBBCODE_SIZE_HINT', 'select font size');
define('_PNBBCODE_SIZE_HUGE', 'Huge');
define('_PNBBCODE_SIZE_LARGE', 'Large');
define('_PNBBCODE_SIZE_NORMAL', 'Normal');
define('_PNBBCODE_SIZE_SMALL', 'Small');
define('_PNBBCODE_SIZE_TEXTSIZE', 'enter text size');
define('_PNBBCODE_SIZE_TINY', 'Tiny');
define('_PNBBCODE_UNDERLINE', 'u');
define('_PNBBCODE_UNDERLINE_HINT', 'underlined text');
define('_PNBBCODE_URL', 'URL');
define('_PNBBCODE_URL_HINT', 'insert a link');
define('_PNBBCODE_YES', 'Yes');

?>