CREATE TABLE `@@DB_MAIN_PREFIX@@_admin_category` (
  `pn_cid` int(10) NOT NULL auto_increment,
  `pn_name` varchar(32) NOT NULL default '',
  `pn_description` varchar(254) NOT NULL default '',
  PRIMARY KEY  (`pn_cid`)
) TYPE=MyISAM AUTO_INCREMENT=6;
INSERT INTO `@@DB_MAIN_PREFIX@@_admin_category` VALUES (1,'System','System Modules'),(2,'Content','Content Modules'),(3,'Resource Pack','Resource Pack Modules'),(4,'Utility','Utility Modules'),(5,'3rd Party','Third Party Modules');
CREATE TABLE `@@DB_MAIN_PREFIX@@_admin_module` (
  `pn_mid` int(10) NOT NULL default '0',
  `pn_cid` int(10) NOT NULL default '0'
) TYPE=MyISAM;
INSERT INTO `@@DB_MAIN_PREFIX@@_admin_module` VALUES (1,1),(2,1),(3,1),(4,1),(5,1),(7,1),(42,1),(30,1),(51,1),(9,1),(21,1),(49,2),(46,2),(41,2),(38,2),(16,2),(24,1),(19,2),(14,2),(33,2),(22,2),(37,4),(25,4),(8,2),(45,2);
CREATE TABLE `@@DB_MAIN_PREFIX@@_autonews` (
  `pn_anid` int(11) NOT NULL auto_increment,
  `pn_catid` int(11) NOT NULL default '0',
  `pn_aid` varchar(30) NOT NULL default '',
  `pn_title` varchar(80) NOT NULL default '',
  `pn_time` varchar(19) NOT NULL default '',
  `pn_hometext` text NOT NULL,
  `pn_bodytext` text NOT NULL,
  `pn_topic` tinyint(4) NOT NULL default '1',
  `pn_informant` varchar(20) NOT NULL default '',
  `pn_notes` text NOT NULL,
  `pn_ihome` tinyint(1) NOT NULL default '0',
  `pn_language` varchar(30) NOT NULL default '',
  `pn_withcomm` int(1) NOT NULL default '0',
  PRIMARY KEY  (`pn_anid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_blocks` (
  `pn_bid` int(11) unsigned NOT NULL auto_increment,
  `pn_bkey` varchar(255) NOT NULL default '',
  `pn_title` varchar(255) NOT NULL default '',
  `pn_content` text NOT NULL,
  `pn_url` varchar(254) NOT NULL default '',
  `pn_mid` int(11) unsigned NOT NULL default '0',
  `pn_position` char(1) NOT NULL default 'l',
  `pn_weight` decimal(10,1) NOT NULL default '0.0',
  `pn_active` tinyint(3) unsigned NOT NULL default '1',
  `pn_refresh` int(11) unsigned NOT NULL default '0',
  `pn_last_update` timestamp NOT NULL,
  `pn_language` varchar(30) NOT NULL default '',
  `pn_collapsable` int(11) NOT NULL default '1',
  `pn_defaultstate` int(11) NOT NULL default '1',
  PRIMARY KEY  (`pn_bid`)
) TYPE=MyISAM AUTO_INCREMENT=16;
INSERT INTO `@@DB_MAIN_PREFIX@@_blocks` VALUES (1,'menu','Main Menu','style:=1\ndisplaymodules:=0\ndisplaywaiting:=0\ncontent:=index.php|Home|Back to the home page..LINESPLITuser.php|My Account|Administer your personal account..LINESPLITadmin.php|Administration|Administer your PostNuked site..LINESPLITuser.php?module=User&op=logout|Logout|Logout of your account..LINESPLIT||LINESPLIT[Downloads]|Downloads|Find downloads listed on this website..LINESPLIT[FAQ]|FAQ|Frequently Asked Questions.LINESPLIT[News]|News|Latest News on this site..LINESPLIT[Reviews]|Reviews|Reviews Section on this website..LINESPLIT[Search]|Search|Search our website..LINESPLIT[Sections]|Sections|Other content on this website..LINESPLIT[Submit_News]|Submit News|Submit an article..LINESPLIT[Topics]|Topics|Listing of news topics on this website..LINESPLIT[Web_Links]|Web Links|Links to other sites..','',0,'l','1.0',1,0,'2001-11-22 14:07:26','',1,1),(2,'menu','Incoming','style:=1\ndisplaymodules:=0\ndisplaywaiting:=1\ncontent:=','',0,'l','2.0',1,0,'0000-00-00 00:00:00','',1,1),(3,'online','Online','','',0,'l','3.0',1,0,'0000-00-00 00:00:00','',1,1),(5,'user','Users Block','Put anything you want here','',0,'l','3.5',1,0,'0000-00-00 00:00:00','',1,1),(6,'search','Search Box','','',0,'l','4.0',0,0,'0000-00-00 00:00:00','',1,1),(8,'thelang','Languages','','',0,'l','6.0',1,0,'0000-00-00 00:00:00','',1,1),(13,'login','Login','','',0,'r','5.0',1,0,'0000-00-00 00:00:00','',1,1),(15,'messages','Administration Messages','','',9,'c','1.0',1,0,'0000-00-00 00:00:00','',1,1);
CREATE TABLE `@@DB_MAIN_PREFIX@@_blocks_buttons` (
  `pn_id` int(11) unsigned NOT NULL auto_increment,
  `pn_bid` int(11) unsigned NOT NULL default '0',
  `pn_title` varchar(255) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_images` longtext NOT NULL,
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_comments` (
  `pn_tid` int(11) NOT NULL auto_increment,
  `pn_pid` int(11) default '0',
  `pn_sid` int(11) default '0',
  `pn_date` datetime default NULL,
  `pn_name` varchar(60) NOT NULL default '',
  `pn_email` varchar(60) default NULL,
  `pn_url` varchar(254) default NULL,
  `pn_host_name` varchar(60) default NULL,
  `pn_subject` varchar(85) NOT NULL default '',
  `pn_comment` text NOT NULL,
  `pn_score` tinyint(4) NOT NULL default '0',
  `pn_reason` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`pn_tid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_counter` (
  `pn_type` varchar(80) NOT NULL default '',
  `pn_var` varchar(80) NOT NULL default '',
  `pn_count` int(11) unsigned NOT NULL default '0'
) TYPE=MyISAM;
INSERT INTO `@@DB_MAIN_PREFIX@@_counter` VALUES ('total','hits',0),('browser','Lynx',0),('browser','MSIE',0),('browser','Opera',0),('browser','Konqueror',0),('browser','Netscape',0),('browser','Bot',0),('browser','Other',0),('os','Windows',0),('os','Linux',0),('os','Mac',0),('os','FreeBSD',0),('os','SunOS',0),('os','IRIX',0),('os','BeOS',0),('os','OS/2',0),('os','AIX',0),('os','Other',0);
CREATE TABLE `@@DB_MAIN_PREFIX@@_downloads_categories` (
  `pn_cid` int(11) NOT NULL auto_increment,
  `pn_title` varchar(50) NOT NULL default '',
  `pn_description` text NOT NULL,
  PRIMARY KEY  (`pn_cid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_downloads_downloads` (
  `pn_lid` int(11) NOT NULL auto_increment,
  `pn_cid` int(11) NOT NULL default '0',
  `pn_sid` int(11) NOT NULL default '0',
  `pn_title` varchar(100) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_description` text NOT NULL,
  `pn_date` datetime default NULL,
  `pn_name` varchar(100) NOT NULL default '',
  `pn_email` varchar(100) NOT NULL default '',
  `pn_hits` int(11) NOT NULL default '0',
  `pn_submitter` varchar(60) NOT NULL default '',
  `pn_ratingsummary` double(6,4) NOT NULL default '0.0000',
  `pn_totalvotes` int(11) NOT NULL default '0',
  `pn_totalcomments` int(11) NOT NULL default '0',
  `pn_filesize` int(11) NOT NULL default '0',
  `pn_version` varchar(10) NOT NULL default '',
  `pn_homepage` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`pn_lid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_downloads_editorials` (
  `pn_id` int(11) NOT NULL default '0',
  `pn_adminid` varchar(60) NOT NULL default '',
  `pn_timestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  `pn_text` text NOT NULL,
  `pn_title` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_downloads_modrequest` (
  `pn_requestid` int(11) NOT NULL auto_increment,
  `pn_lid` int(11) NOT NULL default '0',
  `pn_cid` int(11) NOT NULL default '0',
  `pn_sid` int(11) NOT NULL default '0',
  `pn_title` varchar(100) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_description` text NOT NULL,
  `pn_modifysubmitter` varchar(60) NOT NULL default '',
  `pn_brokendownload` int(3) NOT NULL default '0',
  `pn_name` varchar(100) NOT NULL default '',
  `pn_email` varchar(100) NOT NULL default '',
  `pn_filesize` int(11) NOT NULL default '0',
  `pn_version` varchar(10) NOT NULL default '',
  `pn_homepage` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`pn_requestid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_downloads_newdownload` (
  `pn_lid` int(11) NOT NULL auto_increment,
  `pn_cid` int(11) NOT NULL default '0',
  `pn_sid` int(11) NOT NULL default '0',
  `pn_title` varchar(100) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_description` text NOT NULL,
  `pn_name` varchar(100) NOT NULL default '',
  `pn_email` varchar(100) NOT NULL default '',
  `pn_submitter` varchar(60) NOT NULL default '',
  `pn_filesize` int(11) NOT NULL default '0',
  `pn_version` varchar(10) NOT NULL default '',
  `pn_homepage` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`pn_lid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_downloads_subcategories` (
  `pn_sid` int(11) NOT NULL auto_increment,
  `pn_cid` int(11) NOT NULL default '0',
  `pn_title` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`pn_sid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_downloads_votedata` (
  `pn_id` int(11) NOT NULL auto_increment,
  `pn_lid` int(11) NOT NULL default '0',
  `pn_user` varchar(60) NOT NULL default '',
  `pn_rating` int(11) NOT NULL default '0',
  `pn_hostname` varchar(60) NOT NULL default '',
  `pn_comments` text NOT NULL,
  `pn_timestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_faqanswer` (
  `pn_id` int(6) NOT NULL auto_increment,
  `pn_id_cat` int(6) default NULL,
  `pn_question` text,
  `pn_answer` text,
  `pn_submittedby` varchar(250) NOT NULL default '',
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_faqcategories` (
  `pn_id_cat` int(6) NOT NULL auto_increment,
  `pn_categories` varchar(255) default NULL,
  `pn_language` varchar(30) NOT NULL default '',
  `pn_parent_id` int(6) NOT NULL default '0',
  PRIMARY KEY  (`pn_id_cat`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_group_membership` (
  `pn_gid` int(11) NOT NULL default '0',
  `pn_uid` int(11) NOT NULL default '0'
) TYPE=MyISAM;
INSERT INTO `@@DB_MAIN_PREFIX@@_group_membership` VALUES (2,2);
CREATE TABLE `@@DB_MAIN_PREFIX@@_group_perms` (
  `pn_pid` int(11) NOT NULL auto_increment,
  `pn_gid` int(11) NOT NULL default '0',
  `pn_sequence` int(11) NOT NULL default '0',
  `pn_realm` smallint(4) NOT NULL default '0',
  `pn_component` varchar(255) NOT NULL default '',
  `pn_instance` varchar(255) NOT NULL default '',
  `pn_level` smallint(4) NOT NULL default '0',
  `pn_bond` int(2) NOT NULL default '0',
  PRIMARY KEY  (`pn_pid`)
) TYPE=MyISAM AUTO_INCREMENT=6;
INSERT INTO `@@DB_MAIN_PREFIX@@_group_perms` VALUES (1,2,1,0,'.*','.*',800,0),(2,-1,2,0,'Menublock::','Main Menu:Administration:',0,0),(3,1,3,0,'.*','.*',300,0),(4,0,4,0,'Menublock::','Main Menu:(My Account|Logout|Submit News):',0,0),(5,0,5,0,'.*','.*',200,0);
CREATE TABLE `@@DB_MAIN_PREFIX@@_groups` (
  `pn_gid` int(11) NOT NULL auto_increment,
  `pn_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`pn_gid`)
) TYPE=MyISAM AUTO_INCREMENT=3;
INSERT INTO `@@DB_MAIN_PREFIX@@_groups` VALUES (1,'Users'),(2,'Admins');
CREATE TABLE `@@DB_MAIN_PREFIX@@_headlines` (
  `pn_id` int(11) unsigned NOT NULL auto_increment,
  `pn_sitename` varchar(255) NOT NULL default '',
  `pn_rssuser` varchar(10) default NULL,
  `pn_rsspasswd` varchar(10) default NULL,
  `pn_use_proxy` tinyint(3) NOT NULL default '0',
  `pn_rssurl` varchar(255) NOT NULL default '',
  `pn_maxrows` tinyint(3) NOT NULL default '10',
  `pn_siteurl` varchar(255) NOT NULL default '',
  `pn_options` varchar(20) default '',
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM AUTO_INCREMENT=53;
INSERT INTO `@@DB_MAIN_PREFIX@@_headlines` VALUES (1,'PostNuke',NULL,NULL,0,'http://postnuke.com/backend.php',10,'',''),(2,'LinuxCentral',NULL,NULL,0,'http://linuxcentral.com/backend/lcnew.rdf',10,'',''),(3,'Slashdot',NULL,NULL,0,'http://slashdot.org/slashdot.rdf',10,'',''),(4,'NewsForge',NULL,NULL,0,'http://www.newsforge.com/newsforge.rdf',10,'',''),(5,'PHPBuilder',NULL,NULL,0,'http://phpbuilder.com/rss_feed.php',10,'',''),(6,'Linux.com',NULL,NULL,0,'http://linux.com/mrn/front_page.rss',10,'',''),(7,'Freshmeat',NULL,NULL,0,'http://freshmeat.net/backend/fm.rdf',10,'',''),(9,'LinuxWeeklyNews',NULL,NULL,0,'http://lwn.net/headlines/rss',10,'',''),(11,'Segfault',NULL,NULL,0,'http://segfault.org/stories.xml',10,'',''),(13,'KDE',NULL,NULL,0,'http://www.kde.org/news/kdenews.rdf',10,'',''),(14,'Perl.com',NULL,NULL,0,'http://www.perl.com/pace/perlnews.rdf',10,'',''),(17,'MozillaNewsBot',NULL,NULL,0,'http://www.mozilla.org/newsbot/newsbot.rdf',10,'',''),(21,'SciFi-News',NULL,NULL,0,'http://www.technopagan.org/sf-news/rdf.php',10,'',''),(26,'DrDobbsTechNetCast',NULL,NULL,0,'http://www.technetcast.com/tnc_headlines.rdf',10,'',''),(27,'RivaExtreme',NULL,NULL,0,'http://rivaextreme.com/ssi/rivaextreme.rdf.cdf',10,'',''),(29,'PBSOnline',NULL,NULL,0,'http://cgi.pbs.org/cgi-registry/featuresrdf.pl',10,'',''),(30,'Listology',NULL,NULL,0,'http://listology.com/recent.rdf',10,'',''),(33,'exoScience',NULL,NULL,0,'http://www.exosci.com/exosci.rdf',10,'',''),(39,'DailyDaemonNews',NULL,NULL,0,'http://daily.daemonnews.org/ddn.rdf.php3',10,'',''),(40,'PerlMonks',NULL,NULL,0,'http://www.perlmonks.org/headlines.rdf',10,'',''),(42,'BSDToday',NULL,NULL,0,'http://www.bsdtoday.com/backend/bt.rdf',10,'',''),(45,'HotWired',NULL,NULL,0,'http://www.hotwired.com/webmonkey/meta/headlines.rdf',10,'',''),(52,'SolarisCentral',NULL,NULL,0,'http://www.SolarisCentral.org/news/SolarisCentral.rdf',10,'','');
CREATE TABLE `@@DB_MAIN_PREFIX@@_hooks` (
  `pn_id` int(11) unsigned NOT NULL auto_increment,
  `pn_object` varchar(64) NOT NULL default '',
  `pn_action` varchar(64) NOT NULL default '',
  `pn_smodule` varchar(64) default NULL,
  `pn_stype` varchar(64) default NULL,
  `pn_tarea` varchar(64) NOT NULL default '',
  `pn_tmodule` varchar(64) NOT NULL default '',
  `pn_ttype` varchar(64) NOT NULL default '',
  `pn_tfunc` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_languages_constant` (
  `pn_constant` varchar(32) NOT NULL default '',
  `pn_file` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`pn_constant`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_languages_file` (
  `pn_target` varchar(64) NOT NULL default '',
  `pn_source` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`pn_target`,`pn_source`),
  UNIQUE KEY `source` (`pn_source`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_languages_translation` (
  `pn_language` varchar(32) NOT NULL default '',
  `pn_constant` varchar(32) NOT NULL default '',
  `pn_translation` longblob NOT NULL,
  `pn_level` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`pn_constant`,`pn_language`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_links_categories` (
  `pn_cat_id` int(11) NOT NULL auto_increment,
  `pn_parent_id` int(11) default NULL,
  `pn_title` varchar(50) NOT NULL default '',
  `pn_description` text NOT NULL,
  PRIMARY KEY  (`pn_cat_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_links_editorials` (
  `pn_linkid` int(11) NOT NULL default '0',
  `pn_adminid` varchar(60) NOT NULL default '',
  `pn_timestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  `pn_text` text NOT NULL,
  `pn_title` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`pn_linkid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_links_links` (
  `pn_lid` int(11) NOT NULL auto_increment,
  `pn_cat_id` int(11) NOT NULL default '0',
  `pn_title` varchar(100) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_description` text NOT NULL,
  `pn_date` datetime default NULL,
  `pn_name` varchar(100) NOT NULL default '',
  `pn_email` varchar(100) NOT NULL default '',
  `pn_hits` int(11) NOT NULL default '0',
  `pn_submitter` varchar(60) NOT NULL default '',
  `pn_ratingsummary` double(6,4) NOT NULL default '0.0000',
  `pn_totalvotes` int(11) NOT NULL default '0',
  `pn_totalcomments` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pn_lid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_links_modrequest` (
  `pn_requestid` int(11) NOT NULL auto_increment,
  `pn_lid` int(11) NOT NULL default '0',
  `pn_cat_id` int(11) NOT NULL default '0',
  `pn_sid` int(11) NOT NULL default '0',
  `pn_title` varchar(100) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_description` text NOT NULL,
  `pn_modifysubmitter` varchar(60) NOT NULL default '',
  `pn_brokenlink` tinyint(3) NOT NULL default '0',
  PRIMARY KEY  (`pn_requestid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_links_newlink` (
  `pn_lid` int(11) NOT NULL auto_increment,
  `pn_cat_id` int(11) NOT NULL default '0',
  `pn_title` varchar(100) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_description` text NOT NULL,
  `pn_name` varchar(100) NOT NULL default '',
  `pn_email` varchar(100) NOT NULL default '',
  `pn_submitter` varchar(60) NOT NULL default '',
  PRIMARY KEY  (`pn_lid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_links_votedata` (
  `pn_id` int(11) NOT NULL auto_increment,
  `pn_lid` int(11) NOT NULL default '0',
  `pn_user` varchar(60) NOT NULL default '',
  `pn_rating` int(11) NOT NULL default '0',
  `pn_hostname` varchar(60) NOT NULL default '',
  `pn_comments` text NOT NULL,
  `pn_timestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_message` (
  `pn_mid` int(11) NOT NULL auto_increment,
  `pn_title` varchar(100) NOT NULL default '',
  `pn_content` longtext,
  `pn_date` varchar(14) NOT NULL default '',
  `pn_expire` int(7) NOT NULL default '0',
  `pn_active` int(4) NOT NULL default '1',
  `pn_view` int(1) NOT NULL default '1',
  `pn_language` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`pn_mid`)
) TYPE=MyISAM AUTO_INCREMENT=2;
INSERT INTO `@@DB_MAIN_PREFIX@@_message` VALUES (1,'Welcome to PostNuke, the =-Phoenix-= release (0.761)','<p><a href=\"http://www.postnuke.com\">PostNuke</a> is a weblog/content management system (CMS). It is far more secure and stable than competing products, and is able to work in high-volume environments with ease.<br /><br />\r\nSome of the key features of PostNuke are:</p>\r\n<ul>\r\n<li> customization of all aspects of the web site\'s appearance through themes, with support for CSS stylesheets</li>\r\n<li> the ability to specify items as being suitable for either a single language or for all languages</li>\r\n<li> the best guarantee of properly displaying your web pages in all browsers, thanks to full compliance with W3C HTML standards</li>\r\n<li> a standard API (application programming interface) and extensive documentation to allow for easy extension of your web site\'s functionality through modules and blocks.</li>\r\n</ul>\r\n<p>PostNuke has a very active developer and support community at <a href=\"http://www.postnuke.com\">PostNuke.com</a>.</p>\r\n<p>We hope you will enjoy using PostNuke.<br /><br /><strong>The PostNuke development team </strong></p>\r\n<p><em>Note: you can edit or remove this message by going to the Administration page and clicking on the \'Administration messages\' entry </em></p>','1124647082',0,1,1,'');
CREATE TABLE `@@DB_MAIN_PREFIX@@_module_vars` (
  `pn_id` int(11) unsigned NOT NULL auto_increment,
  `pn_modname` varchar(64) NOT NULL default '',
  `pn_name` varchar(64) NOT NULL default '',
  `pn_value` longtext,
  PRIMARY KEY  (`pn_id`),
  KEY `pn_modname` (`pn_modname`),
  KEY `pn_name` (`pn_name`)
) TYPE=MyISAM AUTO_INCREMENT=148;
INSERT INTO `@@DB_MAIN_PREFIX@@_module_vars` VALUES (1,'Groups','defaultgroup','Users'),(2,'Blocks','collapseable','1'),(3,'Admin','modulesperrow','5'),(4,'Admin','itemsperpage','25'),(5,'Admin','defaultcategory','5'),(6,'Admin','modulestylesheet','navtabs.css'),(7,'Admin','admingraphic','1'),(8,'Admin','startcategory','1'),(9,'Admin','ignoreinstallercheck',''),(10,'Modules','itemsperpage','25'),(11,'Groups','itemsperpage','25'),(12,'/PNConfig','adminmail','s:20:\"postnuke@example.com\";'),(13,'/PNConfig','debug','i:0;'),(14,'/PNConfig','sitename','s:14:\"Your Site Name\";'),(15,'/PNConfig','site_logo','s:8:\"logo.gif\";'),(16,'/PNConfig','slogan','s:16:\"Your slogan here\";'),(17,'/PNConfig','metakeywords','s:208:\"nuke, postnuke, free, community, php, portal, opensource, open source, gpl, mysql, sql, database, web site, website, weblog, content management, contentmanagement, web content management, webcontentmanagement\";'),(18,'/PNConfig','dyn_keywords','i:0;'),(19,'/PNConfig','startdate','s:7:\"08.2005\";'),(20,'/PNConfig','Default_Theme','s:9:\"ExtraLite\";'),(21,'/PNConfig','foot1','s:776:\"<a href=\"http://www.postnuke.com\"><img src=\"images/powered/postnuke.butn.gif\" alt=\"Web site powered by PostNuke\" /></a> <a href=\"http://adodb.sourceforge.net\"><img src=\"images/powered/adodb2.gif\" alt=\"ADODB database library\" /></a> <a href=\"http://www.php.net\"><img src=\"images/powered/php4_powered.gif\" alt=\"PHP Language\" /></a><p>All logos and trademarks in this site are property of their respective owner. The comments are property of their posters, all the rest (c) 2005 by me<br />This web site was made with <a href=\"http://www.postnuke.com\">PostNuke</a>, a web portal system written in PHP. PostNuke is Free Software released under the <a href=\"http://www.gnu.org\">GNU/GPL license</a>.</p>You can syndicate our news using the file <a href=\"backend.php\">backend.php</a>\";'),(22,'/PNConfig','commentlimit','i:4096;'),(23,'/PNConfig','anonymous','s:9:\"Anonymous\";'),(24,'/PNConfig','timezone_offset','i:12;'),(25,'/PNConfig','nobox','i:0;'),(26,'/PNConfig','funtext','i:0;'),(27,'/PNConfig','reportlevel','i:0;'),(28,'/PNConfig','startpage','s:4:\"News\";'),(29,'/PNConfig','admingraphic','i:1;'),(30,'/PNConfig','admart','i:20;'),(31,'/PNConfig','backend_title','s:21:\"PostNuke Powered Site\";'),(32,'/PNConfig','backend_language','s:5:\"en-us\";'),(33,'/PNConfig','seclevel','s:6:\"Medium\";'),(34,'/PNConfig','secmeddays','i:7;'),(35,'/PNConfig','secinactivemins','i:10;'),(36,'/PNConfig','Version_Num','s:7:\"0.7.6.1\";'),(37,'/PNConfig','Version_ID','s:8:\"PostNuke\";'),(38,'/PNConfig','Version_Sub','s:7:\"Phoenix\";'),(39,'/PNConfig','debug_sql','i:0;'),(40,'/PNConfig','anonpost','i:1;'),(41,'/PNConfig','minpass','i:5;'),(42,'/PNConfig','pollcomm','i:1;'),(43,'/PNConfig','minage','i:13;'),(44,'/PNConfig','top','i:10;'),(45,'/PNConfig','storyhome','i:10;'),(46,'/PNConfig','banners','i:0;'),(47,'/PNConfig','myIP','s:15:\"192.168.123.254\";'),(48,'/PNConfig','language','s:3:\"eng\";'),(49,'/PNConfig','anonymoussessions','s:1:\"1\";'),(50,'/PNConfig','multilingual','i:1;'),(51,'/PNConfig','useflags','i:0;'),(52,'/PNConfig','perpage','i:10;'),(53,'/PNConfig','popular','i:500;'),(54,'/PNConfig','newlinks','i:10;'),(55,'/PNConfig','toplinks','i:25;'),(56,'/PNConfig','linksresults','i:10;'),(57,'/PNConfig','links_anonaddlinklock','i:0;'),(58,'/PNConfig','anonwaitdays','i:1;'),(59,'/PNConfig','outsidewaitdays','i:1;'),(60,'/PNConfig','useoutsidevoting','i:1;'),(61,'/PNConfig','anonweight','i:10;'),(62,'/PNConfig','outsideweight','i:20;'),(63,'/PNConfig','detailvotedecimal','i:2;'),(64,'/PNConfig','mainvotedecimal','i:1;'),(65,'/PNConfig','toplinkspercentrigger','i:0;'),(66,'/PNConfig','mostpoplinkspercentrigger','i:0;'),(67,'/PNConfig','mostpoplinks','i:25;'),(68,'/PNConfig','featurebox','i:1;'),(69,'/PNConfig','linkvotemin','i:5;'),(70,'/PNConfig','blockunregmodify','i:0;'),(71,'/PNConfig','newdownloads','i:10;'),(72,'/PNConfig','topdownloads','i:25;'),(73,'/PNConfig','downloadsresults','i:10;'),(74,'/PNConfig','downloads_anonadddownloadlock','i:1;'),(75,'/PNConfig','topdownloadspercentrigger','i:0;'),(76,'/PNConfig','mostpopdownloadspercentrigger','i:0;'),(77,'/PNConfig','mostpopdownloads','i:25;'),(78,'/PNConfig','downloadvotemin','i:5;'),(79,'/PNConfig','notify','i:0;'),(80,'/PNConfig','notify_email','s:15:\"me@yoursite.com\";'),(81,'/PNConfig','notify_subject','s:16:\"NEWS for my site\";'),(82,'/PNConfig','notify_message','s:44:\"Hey! You got a new submission for your site.\";'),(83,'/PNConfig','notify_from','s:9:\"webmaster\";'),(84,'/PNConfig','moderate','i:1;'),(85,'/PNConfig','BarScale','i:1;'),(86,'/PNConfig','tipath','s:14:\"images/topics/\";'),(87,'/PNConfig','userimg','s:11:\"images/menu\";'),(88,'/PNConfig','usergraphic','i:1;'),(89,'/PNConfig','topicsinrow','i:5;'),(90,'/PNConfig','httpref','i:0;'),(91,'/PNConfig','httprefmax','i:1000;'),(92,'/PNConfig','reasons','a:11:{i:0;s:5:\"As Is\";i:1;s:8:\"Offtopic\";i:2;s:9:\"Flamebait\";i:3;s:5:\"Troll\";i:4;s:9:\"Redundant\";i:5;s:10:\"Insightful\";i:6;s:11:\"Interesting\";i:7;s:11:\"Informative\";i:8;s:5:\"Funny\";i:9;s:9:\"Overrated\";i:10;s:10:\"Underrated\";}'),(93,'/PNConfig','AllowableHTML','a:83:{s:3:\"!--\";i:2;s:1:\"a\";i:2;s:4:\"abbr\";i:0;s:7:\"acronym\";i:0;s:7:\"address\";i:0;s:6:\"applet\";i:0;s:4:\"area\";i:0;s:1:\"b\";i:1;s:4:\"base\";i:0;s:8:\"basefont\";i:0;s:3:\"bdo\";i:0;s:3:\"big\";i:0;s:10:\"blockquote\";i:0;s:2:\"br\";i:1;s:6:\"button\";i:0;s:7:\"caption\";i:0;s:6:\"center\";i:0;s:4:\"cite\";i:0;s:4:\"code\";i:0;s:3:\"col\";i:0;s:8:\"colgroup\";i:0;s:3:\"del\";i:0;s:3:\"dfn\";i:0;s:3:\"dir\";i:0;s:3:\"div\";i:0;s:2:\"dl\";i:0;s:2:\"dd\";i:0;s:2:\"dt\";i:0;s:2:\"em\";i:1;s:5:\"embed\";i:0;s:8:\"fieldset\";i:0;s:4:\"font\";i:0;s:4:\"form\";i:0;s:2:\"h1\";i:0;s:2:\"h2\";i:0;s:2:\"h3\";i:0;s:2:\"h4\";i:0;s:2:\"h5\";i:0;s:2:\"h6\";i:0;s:2:\"hr\";i:1;s:1:\"i\";i:1;s:6:\"iframe\";i:0;s:3:\"img\";i:0;s:5:\"input\";i:0;s:3:\"ins\";i:0;s:3:\"kbd\";i:0;s:5:\"label\";i:0;s:6:\"legend\";i:0;s:2:\"li\";i:1;s:3:\"map\";i:0;s:7:\"marquee\";i:0;s:4:\"menu\";i:0;s:4:\"nobr\";i:0;s:6:\"object\";i:0;s:2:\"ol\";i:1;s:8:\"optgroup\";i:0;s:6:\"option\";i:0;s:1:\"p\";i:1;s:5:\"param\";i:0;s:3:\"pre\";i:1;s:1:\"q\";i:0;s:1:\"s\";i:0;s:4:\"samp\";i:0;s:6:\"script\";i:0;s:6:\"select\";i:0;s:5:\"small\";i:0;s:4:\"span\";i:0;s:6:\"strike\";i:0;s:6:\"strong\";i:1;s:3:\"sub\";i:0;s:3:\"sup\";i:0;s:5:\"table\";i:2;s:5:\"tbody\";i:0;s:2:\"td\";i:2;s:8:\"textarea\";i:0;s:5:\"tfoot\";i:0;s:2:\"th\";i:2;s:5:\"thead\";i:0;s:2:\"tr\";i:2;s:2:\"tt\";i:1;s:1:\"u\";i:0;s:2:\"ul\";i:1;s:3:\"var\";i:0;}'),(94,'/PNConfig','CensorList','a:14:{i:0;s:4:\"fuck\";i:1;s:4:\"cunt\";i:2;s:6:\"fucker\";i:3;s:7:\"fucking\";i:4;s:5:\"pussy\";i:5;s:4:\"cock\";i:6;s:4:\"c0ck\";i:7;s:3:\"cum\";i:8;s:4:\"twat\";i:9;s:4:\"clit\";i:10;s:5:\"bitch\";i:11;s:3:\"fuk\";i:12;s:6:\"fuking\";i:13;s:12:\"motherfucker\";}'),(95,'/PNConfig','CensorMode','i:1;'),(96,'/PNConfig','CensorReplace','s:5:\"*****\";'),(97,'/PNConfig','theme_change','i:0;'),(98,'/PNConfig','htmlentities','s:1:\"1\";'),(99,'/PNConfig','UseCompression','i:0;'),(100,'/PNConfig','refereronprint','i:0;'),(101,'/PNConfig','storyorder','s:1:\"1\";'),(102,'/PNConfig','pnAntiCracker','s:1:\"1\";'),(103,'/PNConfig','reg_allowreg','s:1:\"1\";'),(104,'/PNConfig','reg_verifyemail','s:1:\"1\";'),(105,'/PNConfig','reg_Illegalusername','s:87:\"root adm linux webmaster admin god administrator administrador nobody anonymous anonimo\";'),(106,'/PNConfig','reg_noregreasons','s:45:\"Sorry, registration is disabled at this time.\";'),(107,'/PNConfig','loadlegacy','i:0;'),(108,'/PNConfig','newspager','i:0;'),(109,'pnrender','compile_check','1'),(110,'pnrender','force_compile',''),(111,'pnrender','cache',''),(112,'pnrender','expose_template',''),(113,'pnrender','lifetime','3600'),(114,'Xanthia','rootpath','modules'),(115,'Xanthia','vba',''),(116,'Xanthia','enablecache',''),(117,'Xanthia','modulesnocache',''),(118,'Xanthia','db_cache',''),(119,'Xanthia','db_compile',''),(120,'Xanthia','compile_check',''),(121,'Xanthia','use_db',''),(122,'Xanthia','cache_lifetime','3600'),(123,'Xanthia','db_templates',''),(124,'Xanthia','block_control',''),(125,'Xanthia','TopCenter',''),(126,'Xanthia','BotCenter',''),(127,'Xanthia','InnerBlock',''),(128,'Xanthia','shorturls',''),(129,'Xanthia','shorturlsextension','html'),(130,'Xanthia','shorturlsok','1'),(131,'Admin_Messages','itemsperpage','25'),(132,'Mailer','mailertype','1'),(133,'Mailer','charset','iso-8859-1'),(134,'Mailer','encoding','8bit'),(135,'Mailer','contenttype','text/plain'),(136,'Mailer','wordwrap','50'),(137,'Mailer','msmailheaders',''),(138,'Mailer','sendmailpath','/usr/sbin/sendmail'),(139,'Mailer','smtpauth','1'),(140,'Mailer','smtpserver','localhost'),(141,'Mailer','smtpport','25'),(142,'Mailer','smtptimeout','10'),(143,'Mailer','smtpusername',''),(144,'Mailer','smtppassword',''),(145,'legal','termsofuse','1'),(146,'legal','privacypolicy','1'),(147,'legal','accessibilitystatement','1');
CREATE TABLE `@@DB_MAIN_PREFIX@@_modules` (
  `pn_id` int(11) unsigned NOT NULL auto_increment,
  `pn_name` varchar(64) NOT NULL default '',
  `pn_type` int(6) NOT NULL default '0',
  `pn_displayname` varchar(64) NOT NULL default '',
  `pn_description` varchar(255) NOT NULL default '',
  `pn_regid` int(11) unsigned NOT NULL default '0',
  `pn_directory` varchar(64) NOT NULL default '',
  `pn_version` varchar(10) NOT NULL default '0',
  `pn_admin_capable` tinyint(1) NOT NULL default '0',
  `pn_user_capable` tinyint(1) NOT NULL default '0',
  `pn_state` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM AUTO_INCREMENT=53;
INSERT INTO `@@DB_MAIN_PREFIX@@_modules` VALUES (1,'Admin',2,'Administration','Administration',9,'Admin','1.1',1,0,3),(2,'Blocks',2,'Blocks','Administration of side and centre blocks',13,'Blocks','2.2',1,1,3),(3,'Groups',2,'Groups','Modify groups',16,'Groups','1.0',1,0,3),(4,'Modules',2,'Modules','Enable/disable modules, view install/docs/credits.',1,'Modules','2.5',1,0,3),(5,'Permissions',2,'Permissions','Configure permissions',22,'Permissions','0.4',1,0,3),(6,'News',1,'News','News items',7,'News','1.3',0,1,3),(7,'User',1,'User','User Administration',27,'User','0.3',1,0,3),(8,'AddStory',1,'AddStory','Add a story',8,'AddStory','1.0',1,0,3),(9,'Admin_Messages',2,'Admin_Messages','Display automated/programmed messages.',0,'Admin_Messages','1.5',1,0,3),(10,'Autolinks',2,'Autolinks','Automatically link key words',11,'Autolinks','1.0',1,0,1),(11,'AvantGo',2,'AvantGo','AvantGo Mobile News Module',2,'AvantGo','1.4',1,1,1),(12,'Banners',1,'Banners Admin','Administer Banners on your site',12,'Banners','1.0',1,0,1),(13,'Censor',2,'Censor','Site Censorship Control',0,'Censor','1.5',1,0,1),(14,'Comments',1,'Comments','Comment on articles',14,'Comments','1.1',1,1,3),(15,'Credits',2,'Credits','Display Module credits, license, help and contact information',0,'Credits','1.2',0,1,3),(16,'Downloads',1,'Downloads','Files to download',3,'Downloads','1.31',1,1,3),(17,'Ephemerids',2,'Ephemerids','A \'This day in history\' module.',15,'Ephemerids','1.5',1,0,1),(18,'Example',2,'Example','This is an example module for PostNuke CMS',0,'Example','1.2',1,1,1),(19,'FAQ',1,'FAQ','Frequently Asked Questions',4,'FAQ','1.11',1,1,3),(20,'Header_Footer',2,'Header_Footer','Postnuke Page Header and Footer',0,'Header_Footer','1.0',0,1,3),(21,'Languages',1,'Languages','List languages by their ISO Key and name',17,'Languages','1.3',1,0,3),(22,'legal',2,'Legal','Generic Privacy Statement and Terms of Use',0,'legal','1.2',1,1,3),(23,'LostPassword',1,'LostPassword','Retrieve lost password of a user.',18,'LostPassword','0.5',0,0,3),(24,'Mailer',2,'Mailer','Postnuke Mailer',0,'Mailer','1.0',1,0,3),(25,'MailUsers',1,'MailUsers','Mail all/individual users on your site.',19,'MailUsers','1.3',1,0,3),(26,'Members_List',2,'Members_List','Members List',0,'Members_List','1.5',1,1,1),(27,'Messages',2,'Messages','Private messaging system for your site',6,'Messages','1.0',0,1,1),(28,'Multisites',1,'Multisites','Create multiple sites using the same PN installation files',20,'Multisites','0.1',0,0,1),(29,'NewUser',1,'NewUser','New User for postnuke.',21,'NewUser','0.5',0,0,3),(30,'pnRender',2,'pnRender','The Smarty implementation for PostNuke',0,'pnRender','1.0',1,0,3),(31,'pn_bbcode',2,'pn_bbcode','BBCode Hook',164,'pn_bbcode','1.17',1,1,1),(32,'pn_bbsmile',2,'pn_bbsmile','Smilie Hook (Autoincluded)',163,'pn_bbsmile','1.14',1,1,1),(33,'Polls',1,'Polls','Polls and surveys',23,'Polls','1.1',1,1,3),(34,'Quotes',2,'Random Quote','Random quotes',24,'Quotes','1.5',1,0,1),(35,'Ratings',2,'Ratings','Rate PostNuke items',41,'Ratings','1.3',1,1,1),(36,'Recommend_Us',1,'Recommend_Us','Recommend site/Send articles Module',0,'Recommend_Us','1.0',0,1,1),(37,'Referers',1,'Referers','Referers',25,'Referers','1.3',1,0,3),(38,'Reviews',1,'Reviews','Reviews',31,'Reviews','1.0',1,1,3),(39,'RSS',2,'RSS','RSS News Feed Reader',0,'RSS','1.0',1,1,1),(40,'Search',1,'Search','Search this site',32,'Search','1.0',0,1,3),(41,'Sections',1,'Sections','Sections',33,'Sections','1.0',1,1,3),(42,'Settings',1,'Settings','Settings',26,'Settings','1.3',1,0,3),(43,'Sniffer',2,'Sniffer','Browser detection and information',0,'Sniffer','1.1',1,0,1),(44,'Stats',1,'Stats','Site statistics',34,'Stats','1.13',0,1,3),(45,'Submit_News',1,'Submit_News','Contribute a story',0,'Submit_News','1.13',1,1,3),(46,'Topics',1,'Topics','Article topics',37,'Topics','1.0',1,1,3),(47,'Top_List',1,'Top_List','Display top x listings',0,'Top_List','1.0',1,1,1),(48,'typetool',2,'typetool','TypeTool Visual Editor Implementation',0,'typetool','8.0',1,0,1),(49,'Web_Links',1,'Web_Links','Links to other sites',0,'Web_Links','1.0',1,1,3),(50,'Wiki',1,'Wiki','Allow Wiki formatting in the news',28,'Wiki','1.0',0,0,1),(51,'Xanthia',2,'Xanthia','Xanthia Theme Engine',0,'Xanthia','2.1',1,0,3),(52,'Your_Account',1,'Your_Account','User options',0,'Your_Account','0.8',0,0,3);
CREATE TABLE `@@DB_MAIN_PREFIX@@_poll_check` (
  `pn_ip` varchar(20) NOT NULL default '',
  `pn_time` varchar(14) NOT NULL default ''
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_poll_data` (
  `pn_pollid` int(11) NOT NULL default '0',
  `pn_optiontext` char(50) NOT NULL default '',
  `pn_optioncount` int(11) NOT NULL default '0',
  `pn_voteid` int(11) NOT NULL default '0'
) TYPE=MyISAM;
INSERT INTO `@@DB_MAIN_PREFIX@@_poll_data` VALUES (2,'',0,12),(2,'',0,11),(2,'',0,10),(2,'',0,9),(2,'',0,8),(2,'',0,7),(2,'',0,6),(2,'',0,5),(2,'',0,4),(2,'Think? I use it!',0,3),(2,'It is what was needed.',0,2),(2,'What is PostNuke ?',0,1);
CREATE TABLE `@@DB_MAIN_PREFIX@@_poll_desc` (
  `pn_pollid` int(11) NOT NULL auto_increment,
  `pn_title` varchar(100) NOT NULL default '',
  `pn_timestamp` int(11) NOT NULL default '0',
  `pn_voters` mediumint(9) NOT NULL default '0',
  `pn_language` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`pn_pollid`)
) TYPE=MyISAM AUTO_INCREMENT=3;
INSERT INTO `@@DB_MAIN_PREFIX@@_poll_desc` VALUES (2,'What do you think of PostNuke?',995385085,0,'');
CREATE TABLE `@@DB_MAIN_PREFIX@@_pollcomments` (
  `pn_tid` int(11) NOT NULL auto_increment,
  `pn_pid` int(11) default '0',
  `pn_pollid` int(11) default '0',
  `pn_date` datetime default NULL,
  `pn_name` varchar(60) NOT NULL default '',
  `pn_email` varchar(60) default NULL,
  `pn_url` varchar(254) default NULL,
  `pn_host_name` varchar(60) default NULL,
  `pn_subject` varchar(60) NOT NULL default '',
  `pn_comment` text NOT NULL,
  `pn_score` tinyint(4) NOT NULL default '0',
  `pn_reason` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`pn_tid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_queue` (
  `pn_qid` smallint(5) unsigned NOT NULL auto_increment,
  `pn_uid` mediumint(9) NOT NULL default '0',
  `pn_arcd` tinyint(1) NOT NULL default '0',
  `pn_uname` varchar(40) NOT NULL default '',
  `pn_subject` varchar(255) NOT NULL default '',
  `pn_story` text,
  `pn_timestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  `pn_topic` varchar(20) NOT NULL default '',
  `pn_language` varchar(30) NOT NULL default '',
  `pn_bodytext` text,
  PRIMARY KEY  (`pn_qid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_realms` (
  `pn_rid` int(11) NOT NULL auto_increment,
  `pn_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`pn_rid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_referer` (
  `pn_rid` int(11) NOT NULL auto_increment,
  `pn_url` varchar(254) NOT NULL default '',
  `pn_frequency` int(15) default NULL,
  PRIMARY KEY  (`pn_rid`),
  KEY `pn_url` (`pn_url`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_related` (
  `pn_rid` int(11) NOT NULL auto_increment,
  `pn_tid` int(11) NOT NULL default '0',
  `pn_name` varchar(30) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  PRIMARY KEY  (`pn_rid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_reviews` (
  `pn_id` int(11) NOT NULL auto_increment,
  `pn_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `pn_title` varchar(150) NOT NULL default '',
  `pn_text` text NOT NULL,
  `pn_reviewer` varchar(20) default NULL,
  `pn_email` varchar(60) default NULL,
  `pn_score` int(11) NOT NULL default '0',
  `pn_cover` varchar(100) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_url_title` varchar(150) NOT NULL default '',
  `pn_hits` int(11) NOT NULL default '0',
  `pn_language` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_reviews_add` (
  `pn_id` int(11) NOT NULL auto_increment,
  `pn_date` datetime default NULL,
  `pn_title` varchar(150) NOT NULL default '',
  `pn_text` text NOT NULL,
  `pn_reviewer` varchar(20) NOT NULL default '',
  `pn_email` varchar(60) default NULL,
  `pn_score` int(11) NOT NULL default '0',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_url_title` varchar(150) NOT NULL default '',
  `pn_language` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`pn_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_reviews_comments` (
  `pn_cid` int(11) NOT NULL auto_increment,
  `pn_rid` int(11) NOT NULL default '0',
  `pn_userid` varchar(25) NOT NULL default '',
  `pn_date` datetime default NULL,
  `pn_comments` text,
  `pn_score` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pn_cid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_reviews_main` (
  `pn_title` varchar(100) default NULL,
  `pn_description` text
) TYPE=MyISAM;
INSERT INTO `@@DB_MAIN_PREFIX@@_reviews_main` VALUES ('Reviews Section Title','Reviews Section Long Description');
CREATE TABLE `@@DB_MAIN_PREFIX@@_seccont` (
  `pn_artid` int(11) NOT NULL auto_increment,
  `pn_secid` int(11) NOT NULL default '0',
  `pn_title` text NOT NULL,
  `pn_content` text NOT NULL,
  `pn_counter` int(11) NOT NULL default '0',
  `pn_language` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`pn_artid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_sections` (
  `pn_secid` int(11) NOT NULL auto_increment,
  `pn_secname` varchar(40) NOT NULL default '',
  `pn_image` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`pn_secid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_session_info` (
  `pn_sessid` varchar(32) NOT NULL default '',
  `pn_ipaddr` varchar(20) NOT NULL default '',
  `pn_firstused` int(11) NOT NULL default '0',
  `pn_lastused` int(11) NOT NULL default '0',
  `pn_uid` int(11) NOT NULL default '0',
  `pn_vars` blob,
  PRIMARY KEY  (`pn_sessid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_stats_date` (
  `pn_date` varchar(80) NOT NULL default '',
  `pn_hits` int(11) unsigned NOT NULL default '0'
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_stats_hour` (
  `pn_hour` tinyint(2) unsigned NOT NULL default '0',
  `pn_hits` int(11) unsigned NOT NULL default '0'
) TYPE=MyISAM;
INSERT INTO `@@DB_MAIN_PREFIX@@_stats_hour` VALUES (0,0),(1,0),(2,0),(3,0),(4,0),(5,0),(6,0),(7,0),(8,0),(9,0),(10,0),(11,0),(12,0),(13,0),(14,0),(15,0),(16,0),(17,0),(18,0),(19,0),(20,0),(21,0),(22,0),(23,0);
CREATE TABLE `@@DB_MAIN_PREFIX@@_stats_month` (
  `pn_month` tinyint(2) unsigned NOT NULL default '0',
  `pn_hits` int(11) unsigned NOT NULL default '0'
) TYPE=MyISAM;
INSERT INTO `@@DB_MAIN_PREFIX@@_stats_month` VALUES (1,0),(2,0),(3,0),(4,0),(5,0),(6,0),(7,0),(8,0),(9,0),(10,0),(11,0),(12,0);
CREATE TABLE `@@DB_MAIN_PREFIX@@_stats_week` (
  `pn_weekday` tinyint(1) unsigned NOT NULL default '0',
  `pn_hits` int(11) unsigned NOT NULL default '0'
) TYPE=MyISAM;
INSERT INTO `@@DB_MAIN_PREFIX@@_stats_week` VALUES (0,0),(1,0),(2,0),(3,0),(4,0),(5,0),(6,0);
CREATE TABLE `@@DB_MAIN_PREFIX@@_stories` (
  `pn_sid` int(11) NOT NULL auto_increment,
  `pn_catid` int(11) NOT NULL default '0',
  `pn_aid` varchar(30) NOT NULL default '',
  `pn_title` varchar(255) default NULL,
  `pn_time` datetime default NULL,
  `pn_hometext` text,
  `pn_bodytext` text NOT NULL,
  `pn_comments` int(11) default '0',
  `pn_counter` mediumint(8) unsigned default NULL,
  `pn_topic` tinyint(4) NOT NULL default '1',
  `pn_informant` varchar(20) NOT NULL default '',
  `pn_notes` text NOT NULL,
  `pn_ihome` tinyint(1) NOT NULL default '0',
  `pn_themeoverride` varchar(30) NOT NULL default '',
  `pn_language` varchar(30) NOT NULL default '',
  `pn_withcomm` tinyint(1) NOT NULL default '0',
  `pn_format_type` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pn_sid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_stories_cat` (
  `pn_catid` int(11) NOT NULL auto_increment,
  `pn_title` varchar(40) NOT NULL default '',
  `pn_counter` int(11) NOT NULL default '0',
  `pn_themeoverride` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`pn_catid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_addons` (
  `pn_addon_id` int(11) unsigned NOT NULL auto_increment,
  `pn_block_id` int(11) unsigned NOT NULL default '0',
  `pn_addonname` varchar(25) NOT NULL default '',
  `pn_block_function` varchar(200) NOT NULL default '',
  KEY `pn_addon_id` (`pn_addon_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_blcontrol` (
  `pn_module` varchar(64) NOT NULL default '',
  `pn_block` varchar(32) NOT NULL default '',
  `pn_theme` varchar(32) NOT NULL default '',
  `pn_identi` varchar(32) NOT NULL default '',
  `pn_pos` varchar(4) NOT NULL default '',
  `pn_weight` decimal(10,1) NOT NULL default '1.0',
  `pn_template` varchar(50) NOT NULL default '',
  `pn_active` tinyint(1) NOT NULL default '1',
  `pn_always` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`pn_block`,`pn_module`,`pn_theme`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_cache` (
  `cache_id` varchar(32) NOT NULL default '',
  `cache_contents` mediumtext NOT NULL,
  PRIMARY KEY  (`cache_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_config` (
  `skin_id` int(11) NOT NULL default '1',
  `name` varchar(200) NOT NULL default '',
  `description` varchar(60) NOT NULL default '',
  `setting` text NOT NULL,
  `data` text NOT NULL
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_layout` (
  `skin_id` int(11) NOT NULL default '0',
  `zone_label` varchar(255) NOT NULL default '',
  `tpl_file` varchar(200) NOT NULL default '',
  `skin_type` varchar(8) NOT NULL default 'theme',
  KEY `skin_id` (`skin_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_palette` (
  `palette_id` int(11) unsigned NOT NULL auto_increment,
  `palette_name` varchar(32) NOT NULL default '',
  `skin_id` int(11) NOT NULL default '0',
  `pn_module` varchar(64) NOT NULL default '',
  `all_themes` tinyint(1) NOT NULL default '1',
  `background` varchar(12) NOT NULL default '#FFFFFF',
  `color1` varchar(12) NOT NULL default '#FFFFFF',
  `color2` varchar(12) NOT NULL default '#FFFFFF',
  `color3` varchar(12) NOT NULL default '#FFFFFF',
  `color4` varchar(12) NOT NULL default '#FFFFFF',
  `color5` varchar(12) NOT NULL default '#FFFFFF',
  `color6` varchar(12) NOT NULL default '#000000',
  `color7` varchar(12) NOT NULL default '#000000',
  `color8` varchar(12) NOT NULL default '#000000',
  `sepcolor` varchar(12) NOT NULL default '#000000',
  `text1` varchar(12) NOT NULL default '#000000',
  `text2` varchar(12) NOT NULL default '#000000',
  `link` varchar(12) NOT NULL default '#000000',
  `vlink` varchar(12) NOT NULL default '#000000',
  `hover` varchar(12) NOT NULL default '#000000',
  PRIMARY KEY  (`palette_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_skins` (
  `skin_id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `is_active` int(1) NOT NULL default '0',
  `is_multicolor` int(1) NOT NULL default '0',
  PRIMARY KEY  (`skin_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_tplfile` (
  `tpl_id` mediumint(7) unsigned NOT NULL auto_increment,
  `tpl_skin_id` smallint(5) unsigned NOT NULL default '0',
  `tpl_module` varchar(25) NOT NULL default '',
  `tpl_skin_name` varchar(50) NOT NULL default '',
  `tpl_file` varchar(200) NOT NULL default '',
  `tpl_desc` varchar(255) NOT NULL default '',
  `tpl_lastmodified` int(10) unsigned NOT NULL default '0',
  `tpl_lastimported` int(10) unsigned NOT NULL default '0',
  `tpl_type` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`tpl_id`),
  KEY `tpl_skin_id` (`tpl_skin_id`,`tpl_type`),
  KEY `tpl_skin_name` (`tpl_skin_name`,`tpl_file`(10))
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_tplsource` (
  `tpl_id` int(11) unsigned NOT NULL auto_increment,
  `tpl_skin_id` int(11) unsigned NOT NULL default '0',
  `tpl_file_name` varchar(200) NOT NULL default '',
  `tpl_source` mediumtext NOT NULL,
  `tpl_secure` tinyint(1) NOT NULL default '1',
  `tpl_trusted` tinyint(1) NOT NULL default '1',
  `tpl_timestamp` timestamp NOT NULL,
  KEY `tpl_id` (`tpl_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_theme_zones` (
  `zone_id` int(3) NOT NULL auto_increment,
  `skin_id` int(3) NOT NULL default '1',
  `name` varchar(40) NOT NULL default 'No Name',
  `label` varchar(255) NOT NULL default 'addon',
  `type` int(1) NOT NULL default '1',
  `is_active` int(1) NOT NULL default '0',
  `skin_type` varchar(8) NOT NULL default 'theme',
  PRIMARY KEY  (`zone_id`),
  KEY `type` (`type`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_topics` (
  `pn_topicid` tinyint(4) NOT NULL auto_increment,
  `pn_topicname` varchar(255) default NULL,
  `pn_topicimage` varchar(255) default NULL,
  `pn_topictext` varchar(255) default NULL,
  `pn_counter` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pn_topicid`)
) TYPE=MyISAM AUTO_INCREMENT=3;
INSERT INTO `@@DB_MAIN_PREFIX@@_topics` VALUES (2,'Linux','linux.gif','Linux',0),(1,'PostNuke','PostNuke.gif','PostNuke',0);
CREATE TABLE `@@DB_MAIN_PREFIX@@_user_data` (
  `pn_uda_id` int(11) NOT NULL auto_increment,
  `pn_uda_propid` int(11) NOT NULL default '0',
  `pn_uda_uid` int(11) NOT NULL default '0',
  `pn_uda_value` mediumblob NOT NULL,
  PRIMARY KEY  (`pn_uda_id`),
  UNIQUE KEY `index_id_propid` (`pn_uda_propid`,`pn_uda_id`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_user_perms` (
  `pn_pid` int(11) NOT NULL auto_increment,
  `pn_uid` int(11) NOT NULL default '0',
  `pn_sequence` int(6) NOT NULL default '0',
  `pn_realm` int(4) NOT NULL default '0',
  `pn_component` varchar(255) NOT NULL default '',
  `pn_instance` varchar(255) NOT NULL default '',
  `pn_level` int(4) NOT NULL default '0',
  `pn_bond` int(2) NOT NULL default '0',
  PRIMARY KEY  (`pn_pid`)
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_user_property` (
  `pn_prop_id` int(11) NOT NULL auto_increment,
  `pn_prop_label` varchar(255) NOT NULL default '',
  `pn_prop_dtype` int(11) NOT NULL default '0',
  `pn_prop_length` int(11) NOT NULL default '255',
  `pn_prop_weight` int(11) NOT NULL default '0',
  `pn_prop_validation` varchar(255) default NULL,
  PRIMARY KEY  (`pn_prop_id`),
  UNIQUE KEY `pn_prop_label` (`pn_prop_label`)
) TYPE=MyISAM AUTO_INCREMENT=17;
INSERT INTO `@@DB_MAIN_PREFIX@@_user_property` VALUES (1,'_UREALNAME',0,255,1,NULL),(2,'_UREALEMAIL',-1,255,2,NULL),(3,'_UFAKEMAIL',0,255,3,NULL),(4,'_YOURHOMEPAGE',0,255,4,NULL),(5,'_TIMEZONEOFFSET',0,255,5,NULL),(6,'_YOURAVATAR',0,255,6,NULL),(7,'_YICQ',0,255,7,NULL),(8,'_YAIM',0,255,8,NULL),(9,'_YYIM',0,255,9,NULL),(10,'_YMSNM',0,255,10,NULL),(11,'_YLOCATION',0,255,11,NULL),(12,'_YOCCUPATION',0,255,12,NULL),(13,'_YINTERESTS',0,255,13,NULL),(14,'_SIGNATURE',0,255,14,NULL),(15,'_EXTRAINFO',0,255,15,NULL),(16,'_PASSWORD',-1,255,16,NULL);
CREATE TABLE `@@DB_MAIN_PREFIX@@_userblocks` (
  `pn_uid` int(11) NOT NULL default '0',
  `pn_bid` int(11) NOT NULL default '0',
  `pn_active` tinyint(3) NOT NULL default '1',
  `pn_last_update` timestamp NOT NULL
) TYPE=MyISAM;
CREATE TABLE `@@DB_MAIN_PREFIX@@_users` (
  `pn_uid` int(11) NOT NULL auto_increment,
  `pn_name` varchar(60) NOT NULL default '',
  `pn_uname` varchar(25) NOT NULL default '',
  `pn_email` varchar(60) NOT NULL default '',
  `pn_femail` varchar(60) NOT NULL default '',
  `pn_url` varchar(254) NOT NULL default '',
  `pn_user_avatar` varchar(30) default NULL,
  `pn_user_regdate` varchar(20) NOT NULL default '',
  `pn_user_icq` varchar(15) default NULL,
  `pn_user_occ` varchar(100) default NULL,
  `pn_user_from` varchar(100) default NULL,
  `pn_user_intrest` varchar(150) default NULL,
  `pn_user_sig` varchar(255) default NULL,
  `pn_user_viewemail` tinyint(2) default NULL,
  `pn_user_theme` tinyint(3) default NULL,
  `pn_user_aim` varchar(18) default NULL,
  `pn_user_yim` varchar(25) default NULL,
  `pn_user_msnm` varchar(25) default NULL,
  `pn_pass` varchar(40) NOT NULL default '',
  `pn_storynum` tinyint(4) NOT NULL default '10',
  `pn_umode` varchar(10) NOT NULL default '',
  `pn_uorder` tinyint(1) NOT NULL default '0',
  `pn_thold` tinyint(1) NOT NULL default '0',
  `pn_noscore` tinyint(1) NOT NULL default '0',
  `pn_bio` tinytext NOT NULL,
  `pn_ublockon` tinyint(1) NOT NULL default '0',
  `pn_ublock` text NOT NULL,
  `pn_theme` varchar(255) NOT NULL default '',
  `pn_commentmax` int(11) NOT NULL default '4096',
  `pn_counter` int(11) NOT NULL default '0',
  `pn_timezone_offset` float(3,1) NOT NULL default '0.0',
  PRIMARY KEY  (`pn_uid`)
) TYPE=MyISAM AUTO_INCREMENT=3;
INSERT INTO `@@DB_MAIN_PREFIX@@_users` VALUES (1,'','Anonymous','','','','blank.gif','1124647080','','','','','',0,0,'','','','',10,'',0,0,0,'',0,'','',4096,0,12.0),(2,'@@ADMIN_NAME@@','@@ADMIN_NAME@@','@@ADMIN_EMAIL@@','','http://www.postnuke.com','blank.gif','1124647081','','','','','',0,0,'','','','@@ADMIN_PASSWORD@@',10,'',0,0,0,'',0,'','',4096,0,12.0);
